--------------------------------
-------Resource Aware ML--------
--------------------------------
-- File:
--   Util.hs
--
-- Author:
--   Klaus Aehlig (2010)
--
-- Description:

module Util where


splitstream (x:xs) = ([ x ++ "." ++ (show n) | n <- [1..]] ,xs)
the [a] = a


-- map2 is like map but for two lists
map2 f []     []      = []
map2 f (a:as) (b:bs)  = (f a b) : (map2 f as bs)


showWithSep sep []  = ""
showWithSep sep [t] = show t
showWithSep sep (t:ts) = (show t) ++ (sep ++ (showWithSep sep ts))


showSWithSep sep [] = showString ""
showSWithSep sep [t] = showString $ show t
showSWithSep sep (t:ts) = (showString $ show t) . (showString sep) . (showSWithSep sep ts)



mapAppend []     ys f = ys
mapAppend (x:xs) ys f = f x : mapAppend xs ys f

